﻿//
// Copyright (c) 2015, MindFusion LLC - Bulgaria.
//

using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;


namespace MindFusion.Scheduling.Wpf.Samples.CS.StressTest
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();

			calendar.ResourceViewSettings.HeaderStyle.Background =
				calendar.ResourceViewSettings.BottomTimelineSettings.CalendarStyle.Background;
		}

		private void Button_Click(object sender, RoutedEventArgs e)
		{
			Generate(10, 500);
		}

		private void Button1_Click(object sender, RoutedEventArgs e)
		{
			calendar.ItemResources.Clear();
			calendar.Schedule.Resources.Clear();
			calendar.Schedule.Items.Clear();
		}

		private void Generate(int resources, int items)
		{
			DateTime now = DateTime.Now;

			calendar.BeginInit();

			for (int i = 0; i < resources; i++)
			{
				calendar.ItemResources.Add(new Resource()
				{
					Name = string.Format("Resource #{0}", i)
				});
			}

			Random random = new Random(DateTime.Now.Millisecond);
			for (int i = 0; i < items; i++)
			{
				Appointment appointment = new Appointment()
				{
					HeaderText = string.Format("Appointment #{0}", i)
				};
				appointment.Resources.Add(calendar.ItemResources[random.Next() % calendar.ItemResources.Count]);
				appointment.StartTime = calendar.Date.AddDays(random.Next(365));
				appointment.EndTime = appointment.StartTime.AddDays(random.Next(10) + 1);
				calendar.Schedule.Items.Add(appointment);
			}

			calendar.EndInit();

			TimeSpan elapsed = DateTime.Now - now;
			//Label.Text = string.Format("Creation took {0} seconds.", elapsed.TotalSeconds.ToString("#.##"));
		}
	}
}
